package com.tormec.sendkeyboardevent

import android.view.KeyEvent
import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** SendkeyboardeventPlugin */
public class SendkeyboardeventPlugin : FlutterPlugin, MethodCallHandler {

    private lateinit var channel: MethodChannel

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "sendkeyboardevent")
        channel.setMethodCallHandler(this);
    }

    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "sendkeyboardevent")
            channel.setMethodCallHandler(SendkeyboardeventPlugin())
        }
    }

    private lateinit var runtime: Runtime

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) =

            when (call.method) {
                "sendKeyboardEvent" -> {

                    var isRuntimeInitialized = true

                    if(!::runtime.isInitialized) {
                        isRuntimeInitialized = false
                        runtime = Runtime.getRuntime()
                    }

                    val keyCode = call.argument<Int>("keyCode")
                    val keyCommand = "input keyevent $keyCode"
                    runtime.exec(keyCommand)

                    result.success("Sent ${KeyEvent.KEYCODE_MENU} event, was runtime initialized: $isRuntimeInitialized")

                }
                "sendKeyboardText" -> {

                    var isRuntimeInitialized2 = true

                    if(!::runtime.isInitialized) {
                        isRuntimeInitialized2 = false
                        runtime = Runtime.getRuntime()
                    }

                    val text = call.argument<String>("text")
                    val keyCommand = "input text $text"
                    runtime.exec(keyCommand)

                    result.success("Sent ${KeyEvent.KEYCODE_MENU} event, was runtime initialized: $isRuntimeInitialized2")

                }
                "sendADBCommand" -> {

                    if(!::runtime.isInitialized)  {
                        runtime = Runtime.getRuntime()
                    }

                    val command = call.argument<String>("command")
                    runtime.exec(command)

                    result.success("Sent adb command: $command")

                }
                else -> {
                    result.notImplemented();
                }
            }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }
}
